VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "howto_credit_card_calculator"
   ClientHeight    =   3015
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8640
   LinkTopic       =   "Form1"
   ScaleHeight     =   3015
   ScaleWidth      =   8640
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtMinPayment 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1680
      TabIndex        =   8
      Text            =   "$15.00"
      Top             =   1200
      Width           =   1215
   End
   Begin VB.TextBox txtInitialBalance 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1680
      TabIndex        =   4
      Text            =   "$5,000.00"
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtInterestRate 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1680
      TabIndex        =   3
      Text            =   "18.90%"
      Top             =   480
      Width           =   1215
   End
   Begin VB.TextBox txtPaymentPercent 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1680
      TabIndex        =   2
      Text            =   "4.00%"
      Top             =   840
      Width           =   1215
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   1320
      TabIndex        =   1
      Top             =   1680
      Width           =   855
   End
   Begin MSComctlLib.ListView lvwPayments 
      Height          =   2415
      Left            =   3000
      TabIndex        =   0
      Top             =   120
      Width           =   4215
      _ExtentX        =   7435
      _ExtentY        =   4260
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Object.Width           =   1270
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Alignment       =   1
         SubItemIndex    =   1
         Text            =   "Payment"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Alignment       =   1
         SubItemIndex    =   2
         Text            =   "Interest"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Alignment       =   1
         SubItemIndex    =   3
         Text            =   "Balance"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.Label lblResult 
      Alignment       =   1  'Right Justify
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Left            =   5040
      TabIndex        =   11
      Top             =   2640
      Width           =   1215
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Min Payment:"
      Height          =   195
      Index           =   5
      Left            =   120
      TabIndex        =   10
      Top             =   1200
      Width           =   960
   End
   Begin VB.Label lblResultPrompt 
      AutoSize        =   -1  'True
      Caption         =   "Total Payments:"
      Height          =   195
      Left            =   3840
      TabIndex        =   9
      Top             =   2640
      Width           =   1140
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Initial Balance:"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   1035
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Interest Rate:"
      Height          =   195
      Index           =   1
      Left            =   120
      TabIndex        =   6
      Top             =   480
      Width           =   960
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Payment %:"
      Height          =   195
      Index           =   2
      Left            =   120
      TabIndex        =   5
      Top             =   840
      Width           =   825
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Calculate the payments.
Private Sub cmdGo_Click()
Dim balance As Double
Dim interest_rate As Double
Dim payment_percent As Double
Dim min_payment As Double
Dim total_payments As Double
Dim new_item As ListItem
Dim payment As Double
Dim interest As Double
Dim i As Integer
    
    ' Get the parameters.
    balance = ParseCurrency(txtInitialBalance.Text)
    interest_rate = ParsePercent(txtInterestRate.Text) / 12
    payment_percent = ParsePercent(txtPaymentPercent.Text)
    min_payment = ParseCurrency(txtMinPayment.Text)

    lblResult.Caption = ""
    total_payments = 0

    ' Display the initial balance.
    lvwPayments.ListItems.Clear
    Set new_item = lvwPayments.ListItems.Add(Text:="0")
    new_item.ListSubItems.Add Text:=""
    new_item.ListSubItems.Add Text:=""
    new_item.ListSubItems.Add Text:=FormatCurrency$(balance)

    ' Loop until balance == 0.
    i = 1
    Do While (balance > 0)
        ' Calculate the payment.
        payment = balance * payment_percent
        If (payment < min_payment) Then payment = min_payment

        ' Calculate interest.
        interest = balance * interest_rate
        balance = balance + interest

        ' See if we can pay off the balance.
        If (payment > balance) Then payment = balance
        total_payments = total_payments + payment
        balance = balance - payment

        ' Display results.
        Set new_item = lvwPayments.ListItems.Add(Text:=Format$(i))
        new_item.ListSubItems.Add Text:=FormatCurrency$(payment)
        new_item.ListSubItems.Add Text:=FormatCurrency$(interest)
        new_item.ListSubItems.Add Text:=FormatCurrency$(balance)

        ' Process the next month.
        i = i + 1
    Loop

    ' Display the total payments.
    lblResult.Caption = FormatCurrency$(total_payments)
    lvwPayments.ListItems(lvwPayments.ListItems.Count).EnsureVisible
End Sub

' Arrange controls.
Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    lblResult.Top = ScaleHeight - lblResult.Height - 120
    lblResultPrompt.Top = lblResult.Top

    wid = ScaleWidth - lvwPayments.Left - 120
    If wid < 120 Then wid = 120
    hgt = lblResult.Top - 2 * 120
    If hgt < 120 Then hgt = 120
    
    lvwPayments.Move lvwPayments.Left, 120, wid, hgt
End Sub

' Convert a string into a double value.
Private Function ParseCurrency(ByVal txt As String) As Double
    txt = Replace$(txt, "$", "")
    txt = Replace$(txt, ",", "")
    ParseCurrency = CCur(txt)
End Function

' Convert a string into a percentage value.
Private Function ParsePercent(ByVal txt As String) As Double
    txt = Replace$(txt, "%", "")
    txt = Replace$(txt, ",", "")
    ParsePercent = CCur(txt) / 100
End Function
